﻿' Read from Arduino VB Example - More Information at: https://www.aeq-web.com

Imports System
Imports System.IO.Ports

Public Class Form1

    Dim SerialPort As String
    Dim RxData As String = ""

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Enabled = False
        SerialPort = ""
        For Each sp As String In My.Computer.Ports.SerialPortNames
            com_port.Items.Add(sp)
        Next
    End Sub


    Private Sub SerialPort_ComboBox_SelectedIndexChanged(sender As Object, e As EventArgs) Handles com_port.SelectedIndexChanged
        If (com_port.SelectedItem <> "") Then
            SerialPort = com_port.SelectedItem
        End If
    End Sub


    Private Sub connect_BTN_Click(sender As Object, e As EventArgs) Handles connect_btn.Click
        If (connect_btn.Text = "Connect") Then
            If (SerialPort <> "") Then
                SerialPort1.Close()
                SerialPort1.PortName = SerialPort
                SerialPort1.BaudRate = 9600
                SerialPort1.DataBits = 8
                SerialPort1.Parity = Parity.None
                SerialPort1.StopBits = StopBits.One
                SerialPort1.Handshake = Handshake.None
                SerialPort1.Encoding = System.Text.Encoding.Default 'very important!
                SerialPort1.ReadTimeout = 10000

                SerialPort1.Open()
                connect_btn.Text = "Disconnect"
                Timer1.Enabled = True
            Else
                MsgBox("Please choose Serial Port")
            End If
        Else
            SerialPort1.Close()
            connect_btn.Text = "Connect"
            Timer1.Enabled = False
        End If


    End Sub


    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick

        'Read Serial Data and split it to text boxes
        RxData = ReceiveSerialData()
        Dim rxpacket As String() = RxData.Split(";")
        Dim rxprams As String() = rxpacket(0).Split(",")
        TB_P1.Text = rxprams(0)
        TB_P2.Text = rxprams(1)
        TB_P3.Text = rxprams(2)

    End Sub


    Function ReceiveSerialData() As String
        Dim Incoming As String
        Try
            Incoming = SerialPort1.ReadExisting()
            If Incoming Is Nothing Then
                Return "no-data" & vbCrLf
            Else
                Return Incoming
            End If
        Catch ex As TimeoutException
            Return "Error: Serial Port timeout."
        End Try

    End Function

End Class
